/*
    MPEG Maaate: An Australian MPEG audio analysis toolkit
    Copyright (C) 2000 Commonwealth Scientific and Industrial Research Organisation
    (CSIRO), Australia.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "module.H"
#include "pluginsPlatform.h"

Module
loadvarianceModule (void);
void unloadvarianceModule(void);

Module
loadSumscfModule (void);
void unloadSumscfModule(void);

Module
loadlowNrjModule (void);
void unloadlowNrjModule(void);

Module
loadCentroidModule (void);
void unloadCentroidModule(void);

Module
loadSegmentationModule (void);
void unloadSegmentationModule(void);

Module
loadHistogram1DModule (void);
void unloadHistogram1DModule(void);

Module
loadSilenceModule (void);
void unloadSilenceModule(void);

Module
loadNoiseModule (void);
void unloadNoiseModule(void);

Module
loadBgNoiseLevelModule (void);
void unloadBgNoiseLevelModule(void);

Module
loadSBnrjModule (void);
void unloadSBnrjModule(void);

Module
loadSBmeanModule (void);
void unloadSBmeanModule(void);

Module
loadSBrmsModule (void);
void unloadSBrmsModule(void);

Module
loadSBscfModule (void);
void unloadSBscfModule(void);

Module
loadSBvalueModule (void);
void unloadSBvalueModule(void);

Module
loadSBvaluemeanModule (void);
void unloadSBvaluemeanModule(void);

Module
loadSBvaluermsModule (void);
void unloadSBvaluermsModule(void);

Module
loadSBvaluenrjModule (void);
void unloadSBvaluenrjModule(void);

Module
loadsignalnrjModule (void);
void unloadsignalnrjModule(void);

Module
loadbandnrjModule (void);
void unloadbandnrjModule(void);

Module
loadsigsbModule (void);
void unloadsigsbModule(void);

Module
loadsignalMagnitudeModule (void);
void unloadsignalMagnitudeModule(void);

Module
loadpauseRateModule (void);
void unloadpauseRateModule(void);

Module
loadBandNrjRatioModule (void);
void unloadBandNrjRatioModule(void);

Module
loadrollOffModule (void);
void unloadrollOffModule(void);

Module
loadbandwidthModule (void);
void unloadbandwidthModule(void);

Module
loadsigBdwidthModule (void);
void unloadsigBdwidthModule(void);

Module
loadspectralFluxModule (void);
void unloadspectralFluxModule(void);

Module
loadcentralMomentModule (void);
void unloadcentralMomentModule(void);


extern "C" {


//ModuleList loadModules (void)
//list<Module> loadModules (void)
CSAPI_PLUGINS
void* loadModules (void)
{
  static list<Module> modules;
  modules.push_back(loadvarianceModule());
  modules.push_back(loadSumscfModule());
  modules.push_back(loadlowNrjModule());
  modules.push_back(loadCentroidModule());
  modules.push_back(loadSegmentationModule());
  modules.push_back(loadHistogram1DModule());
  modules.push_back(loadSilenceModule());
  modules.push_back(loadNoiseModule());
  modules.push_back(loadBgNoiseLevelModule());
  modules.push_back(loadSBnrjModule());
  modules.push_back(loadSBmeanModule());
  modules.push_back(loadSBrmsModule());
  modules.push_back(loadSBscfModule());
  modules.push_back(loadSBvalueModule());
  modules.push_back(loadSBvaluenrjModule());
  modules.push_back(loadSBvaluemeanModule());
  modules.push_back(loadSBvaluermsModule());
  modules.push_back(loadsignalnrjModule());
  modules.push_back(loadsigsbModule());
  modules.push_back(loadbandnrjModule());
  modules.push_back(loadsignalMagnitudeModule());
  modules.push_back(loadpauseRateModule());;
  modules.push_back(loadBandNrjRatioModule());
  modules.push_back(loadrollOffModule());
  modules.push_back(loadbandwidthModule());
  modules.push_back(loadsigBdwidthModule());
  modules.push_back(loadspectralFluxModule());  
  modules.push_back(loadcentralMomentModule());  
  return &modules;
}

CSAPI_PLUGINS
void
unloadModules (void)
{
  //xxx: not implemented yet
}

}
