/*
    MPEG Maaate: An Australian MPEG audio analysis toolkit
    Copyright (C) 2000 Commonwealth Scientific and Industrial Research Organisation
    (CSIRO), Australia.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <cmath>
#include "plugins.H"

CSAPI_TIER2 Plugins *
maaateA_new_plugins()
{
  return new Plugins();
}

CSAPI_TIER2 void
maaateA_delete_plugins(Plugins * plugin)
{
  delete plugin;
}

CSAPI_TIER2 void
maaateA_add_libraries_maaate_path (Plugins * plugin)
{
  plugin->AddLibrariesMaaatePath ();
}

CSAPI_TIER2 void
maaateA_add_static_modules(Plugins * plugin)
{
  plugin->AddStaticModules();
}

CSAPI_TIER2 int
maaateA_add_library(Plugins * plugin, char * filename)
{
  return plugin->AddLibrary(string(filename));
}

CSAPI_TIER2 void
maaateA_add_libraries(Plugins * plugin, char * dirname)
{
  plugin->AddLibraries(string(dirname));
}

CSAPI_TIER2 void
maaateA_add_libraries_path(Plugins * plugin, char * pathlist)
{
  plugin->AddLibrariesPath(string(pathlist));
}

CSAPI_TIER2 void
maaateA_add_module(Plugins * plugin, Module * module)
{
  plugin->AddModule(module);
}

CSAPI_TIER2 void
maaateA_remove_library(Plugins * plugin, char * name)
{
  plugin->RemoveLibrary(string(name));
}

CSAPI_TIER2 void
maaateA_remove_module(Plugins * plugin, Module * module)
{
  plugin->RemoveModule(module);
}

CSAPI_TIER2 ModuleList *
maaateA_modules(Plugins * plugin)
{
  return plugin->Modules();
}

CSAPI_TIER2 Module * 
maaateA_get_module(Plugins * plugin, char * name)
{
  return plugin->GetModule(string(name));
}

CSAPI_TIER2 ModuleList *
maaateA_library_modules(Plugins * plugin, char * name)
{
  return plugin->LibraryModules(string(name));
}

