/*
    MPEG Maaate: An Australian MPEG audio analysis toolkit
    Copyright (C) 2000 Commonwealth Scientific and Industrial Research Organisation
    (CSIRO), Australia.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <cmath>
#include "segmentTable.H"


CSAPI_TIER2 SegmentTable * maaateA_st_new  ()
{
  return new SegmentTable();
}

CSAPI_TIER2 SegmentTable * maaateA_st_copy(SegmentTable * st)
{
  return new SegmentTable(*st);
}

CSAPI_TIER2 SegmentTable * maaateA_st_invert_table(SegmentTable * st, double endTime)
{
  return st->invertTable(endTime);
}

CSAPI_TIER2 void maaateA_st_delete (SegmentTable *st)
{
  delete st;
}

CSAPI_TIER2 int maaateA_st_smaller (SegmentTable *st1, SegmentTable *st2)
{
  return ((*st1) < (*st2));
}

CSAPI_TIER2 int maaateA_st_bigger (SegmentTable *st1, SegmentTable *st2)
{
  return ((*st1) > (*st2));
}

CSAPI_TIER2 void   maaateA_st_print(SegmentTable * st)
{
  st->print();
}

CSAPI_TIER2 void   maaateA_st_print_plain(SegmentTable * st, int negative)
{
  st->printPlain(negative);
  return;
}

CSAPI_TIER2 SegmentData *
maaateA_st_element_at(SegmentTable * st, int i)
{
  return &((*st)[i]);
}

CSAPI_TIER2 SegmentData *
maaateA_st_get_segment(SegmentTable * st, double time, QuerySegmentType which)
{
  return st->getSegment(time, which);
}

CSAPI_TIER2 int
maaateA_st_get_segment_index(SegmentTable * st, double time)
{
  return st->getSegmentIndex(time);
}

CSAPI_TIER2 void   maaateA_st_append(SegmentTable * st, SegmentData *sd)
{
  st->append(*sd);
}

CSAPI_TIER2 void   maaateA_st_insert_st(SegmentTable * st, SegmentTable * sti)
{
  st->insert(*sti);
}

CSAPI_TIER2 void   maaateA_st_erase(SegmentTable * st, int ndx)
{
  st->erase(ndx);
}

CSAPI_TIER2 void   maaateA_st_clear (SegmentTable *st)
{
  st->clear();
}

CSAPI_TIER2 int    maaateA_st_get_size(SegmentTable * st)
{
  return st->size();
}

CSAPI_TIER2 int    maaateA_st_empty(SegmentTable * st)
{
  return st->empty();
}

CSAPI_TIER2 double maaateA_avg_duration(SegmentTable * st)
{
  return st->avgDuration();
}

CSAPI_TIER2 double maaateA_min_duration(SegmentTable * st)
{
  return st->minDuration();
}
 
CSAPI_TIER2 double maaateA_max_duration(SegmentTable * st)
{
  return st->maxDuration();
}
